#include "unzip.h"
#include "gpstdio.h"
#include "gpdef.h"
#include "gpstdlib.h"
#include "gpgraphic.h"
#include "gpmm.h"
#include "gpgraphic16.h"

#include "gpmain.h"
#include "./include/global.h"
#include "./include/graphics16.h"
#include "./include/okf.h"
#include "./include/fileSelector.h"

#include "project.h"
#include "fonts.h"
#include "background.h"


typedef  unsigned char  uint8;
byte *filebuf;
FILESELECTOR fileSelector;

char Load_Zip(char *ZipName)
{
  F_HANDLE fp;
  unsigned long filesize;
  int l;
  unzFile zip_file = 0;    
  char name_file[256]; //yoyo
  unz_file_info unzinfo;
  
  char path[50];
  char info[50];

  l=15;	
  int port;
  
    GpSurfaceSet(&gtSurface[giSurface]);
	GpRectFill16(NULL, &gtSurface[giSurface], 0, 0, GPC_LCD_WIDTH, GPC_LCD_HEIGHT, RGB(7, 15, 7));
  	zip_file = unzOpen(ZipName);
	OkfPrintAt(10, 10, ZipName);
	
  	if (!zip_file) {
	  OkfPrintAt(10, 25, "This isn't a valid zip file!!");
	  return 1;
	}
	
	port = unzGoToFirstFile(zip_file);
	
	while (port == UNZ_OK)
	{
		if (l>=210)
		  {GpRectFill16(NULL, &gtSurface[giSurface], 0, 0, GPC_LCD_WIDTH, GPC_LCD_HEIGHT, RGB(7, 15, 7));
		   l=0;
		  }
		unzGetCurrentFileInfo(zip_file, &unzinfo, name_file, sizeof(name_file), NULL, 0, NULL, 0);
		unzOpenCurrentFile (zip_file);
		filesize = unzinfo.uncompressed_size;
	    filebuf=(uint8 *)gm_malloc(filesize);
		unzReadCurrentFile(zip_file, filebuf, filesize);
	
	gm_sprintf(info, "Unpacking.... %s", name_file);
	OkfPrintAt(10, l+=10, info);
	
	gm_sprintf(path, "%s\\%s", fileSelector.currentPath, name_file);
	
	
	if(GpFileCreate(path,ALWAYS_CREATE,&fp)==SM_OK){
			GpFileClose(fp);
			if(GpFileOpen(path,OPEN_W,&fp)==SM_OK)
			{
	
			GpFileWrite(fp, filebuf,filesize); 
			GpFileClose(fp);
			OkfPrintAt(250, l, "OK");
			}
			else OkfPrintAt(250, l, "Error!!");
		}
	else OkfPrintAt(250, l, "Error!!");
		
	port = unzGoToNextFile(zip_file);
	}
	unzCloseCurrentFile (zip_file);
	unzClose (zip_file);
	
	OkfPrintAt(10, l+=15, "Done. Press a button");
  
  return 0;
}


static void Initialize(void)
{
  InitGraphics(16);
  giSurface = 1;
  GpFatInit();

  OkfInitialize(gtSurface, &giSurface);
  OkfRegister(verdana10_okf);
  OkfRegister(verdana8b_p_okf);
  OkfRegister(comicSansMS12b_pm_okf);
  OkfClone(3);
  OkfApplyEffect(okf.pFonts->lastHandle, okfOverlay, RGB(31, 31, 31), 15);
  OkfClone(3);
  OkfApplyEffect(okf.pFonts->lastHandle, okfOverlay, RGB(15, 31, 15), 15);
  OkfClone(3);
  OkfGetFont(okf.pFonts->lastHandle)->pOkf->alphaMask = FALSE;

  // Initialize graphics.h alpha blending look up table
  gtAlphaLUT = okf.alphaLUT.pLUT;
  giAlphaLevels = okf.alphaLUT.levels;
}

static void Terminate(void)
{
  OkfTerminate();
}


static void MainMenu(void)
{
  char tmp_string[64];
  
  FileSelectorInit(&fileSelector);
  
  fileSelector.pFileSizeFormat = " %s";
  fileSelector.pTotalsFormat = "%s bytes, %s files";
  fileSelector.pFilters = "*.zip";

  fileSelector.pathLeft = 12;
  fileSelector.pathTop  = 6;
  fileSelector.listTop  = 57;
  fileSelector.listSize = 6;
  fileSelector.fileLeft = 51;
  fileSelector.fileYDisplacement = -3;
  fileSelector.sizeRight = 290;
  fileSelector.sizeYDisplacement = -2;
  fileSelector.totalsLeft = 13;
  fileSelector.totalsTop = 207;
  fileSelector.scrollBarLeft = 18;
  fileSelector.selectionHeight = 21;
  fileSelector.selectionMargin = 15;

  fileSelector.showExtensions = TRUE;
  fileSelector.showSeparationLines = FALSE;

  fileSelector.pathFont = 5;
  fileSelector.folderFont = 4;
  fileSelector.fileFont = 3;
  fileSelector.sizesFont = 6;
  fileSelector.totalsFont = 5;

  fileSelector.pBackground = (unsigned short *) background;
  fileSelector.backColor = RGB(0, 0, 0);
  fileSelector.selectionColor = RGB(31, 31, 31);
  fileSelector.selectionIntensity = 16;
  fileSelector.scrollBarColor = RGB(31, 31, 31);

  //File Selector 2
  while (FileSelector(&fileSelector) == 1)
  {
    okf.font = 2;
	//GpClockSpeedChange(132000000, 0x3a011, 3); //133Mhz
	GpClockSpeedChange (156000000, 0x2c001, 3); //156Mhz
	Load_Zip(fileSelector.filename);
	GpClockSpeedChange (67500000, 0x25002, 2); //66Mhz
    SurfaceFlip();
    while (GpKeyGet());
    while (!GpKeyGet());
    while (GpKeyGet());
  }
}

void GpMain (void * arg)
{
  Initialize();
  MainMenu();
  Terminate();
  GpAppExit();
}
