//////////////////////////////////////////////////// 
// CPU FREQUENCE FOR GP32 // 
//////////////////////////////////////////////////// 
// By ThunderZ // 
//////////////////////////////////////////////////// 
// Thanks to all GP32 community for make this // 
// table possible. // 
//////////////////////////////////////////////////// 
// WARNING, you use it at your how risk !!! // 
//////////////////////////////////////////////////// 

// Modified by Oankali
// oankali@nekanium.com
// www.nekanium.com


#include <gpstdlib.h>

#include "clock.h"


// Global variables
#ifdef WIN32
  int gTicksPerSecond = 998;
#else
  int gTicksPerSecond = 958;
#endif



// Set GP32 clock
void SetClockSpeed(int nClockSpeed) 
{ 
  // clkdvn MCLK HCLK PCLK 
  // 0 1 1 1 
  // 1 1 1 1/2 
  // 2 1 1/2 1/2 
  // 3 1 1/2 1/4 
  
  switch (nClockSpeed) 
  { 
    case CLOCK16: 
      // 16.5
      GpClockSpeedChange (16500000, 0x71142, 0); 
      gTicksPerSecond = 930;
      break; 
    case CLOCK33: 
      // 33
      GpClockSpeedChange (33000000, 0x24003, 0); 
      gTicksPerSecond = 1863;
      break; 
    case CLOCK40: 
      // 40, 1
      GpClockSpeedChange (40000000, 0x48013, 1); 
      gTicksPerSecond = 1130;
      break; 
    case CLOCK60: 
      // 59.2, 1 
      GpClockSpeedChange(59250000, 0x47022, 1); 
      gTicksPerSecond = 1680;
      break; 
    case CLOCK67: 
      // 67.5, 2 
      GpClockSpeedChange(67500000, 0x25021, 2); 
      gTicksPerSecond = 1914;
      break; 
    case CLOCK80: 
      // 80, 1 
      GpClockSpeedChange(80000000, 0x48012, 1); 
      gTicksPerSecond = 2266;
      break; 
    case CLOCK102: 
      // 102, 2 
      GpClockSpeedChange(102000000, 0x1a020, 2); 
      gTicksPerSecond = 2889;
      break; 
    case CLOCK132: 
      // 132, 3 
      GpClockSpeedChange(132000000, 0x3a011, 3); 
      gTicksPerSecond = 1864;
      break; 
  } 

#ifdef WIN32
  gTicksPerSecond = 998;
#endif
} 
