/*************************************************************************

  global.h v1.0

    Some global functions and variables.
    global.h is part of the Oankali's GP32 run-time library.

  Copyright (c) 2004 by
  Guillem Reinoso <oankali@nekanium.com>
  www.nekanium.com

  These software is freeware and is provided as is.
  If it doesn't work for you or it makes your PC or GP32 melt down, it's not my
  responsibility.
  If you use it in your programs, cite me please.

**************************************************************************/


#ifndef __global_h__
#define __global_h__

#ifdef __cplusplus
extern "C" {
#endif


extern GPDRAWSURFACE gtSurface[2];
extern int giSurface;


// Macro definitions
#ifdef SHOWMEM
#define SurfaceFlip() \
{\
  char str[10];\
  GpRectFill16(NULL, &gtSurface[giSurface], 0, 0 , 57, 12, 0x0000);\
  gm_sprintf(str, "%07ld", gm_availablesize());\
  GpTextOut16(NULL, &gtSurface[giSurface], 0, -4, str, 0xFFFF);\
  GpSurfaceFlip(&gtSurface[giSurface]);\
  giSurface ^= 0x01;\
}
#else
#define SurfaceFlip() \
{\
  GpSurfaceFlip(&gtSurface[giSurface]);\
  giSurface ^= 0x01;\
}
#endif

// Prototypes
void GetKeys(int *pressedKeys);
void InitGraphics(int depth);
void PushKey();
char *Thousands(char *number);
void Wait(unsigned int ticks);
int WaitKey(unsigned int ticks);


#ifdef __cplusplus
  }
#endif

#endif /*__global_h__*/
